Subject: Re: [PATCH] [IPV4] Fix secondary IP addresses after promotion

From: Patrick McHardy <[email-masked]>
Date: Sat, 05 Nov 2005 05:28:40 +0100

Patrick McHardy wrote:
> Thomas Graf wrote:
> 
>> broadcast 10.0.0.0  proto kernel  scope link  src 10.0.0.2 local 
>> 10.0.0.2  proto kernel  scope host  src 10.0.0.2 broadcast 10.0.0.255  
>> proto kernel  scope link  src 10.0.0.2
>> Local routes for 10.0.0.3 and 10.0.0.4 have disappeared _without_
>> any notification.
>>
>> I think the correct way to fix this is to prevent the deletion of
>> the local routes, not just readding them. _If_ the deletion of them
>> is intended, which I doubt, then at least notifications must be
>> sent out.
> 
> I agree, the routes should ideally not be deleted at all. The missing
> notifications appear to be a different bug. Let me have another look ..

The reason why all routes are deleted is because their prefered
source addresses is the primary address. fn_flush_list should
probably send the missing notifications for the deleted routes.
Changing address promotion to not delete the other routes at all
looks extremly complicated, I think just fixing it to behave
correctly is good enough (which my patch didn't do entirely,
I'll send a new one this weekend).